#include "const.h"
#include <vector>
#include <Eigen/Dense>

using namespace Eigen;
using namespace std;

class Sector
{


public:
	Sector();
	~Sector();

	int    ** PMI_read;  // changed
	double ** CQI_read;  // changed
	double ** CQI_AVR;
	double ** METRIC;
	int    ** MCS_decision; // eNB decide mcs type corresponding to ue's cqi
	int    ** CQIndex_decision; // 


	vector < int > ue_in_control;
	VectorXd ue_scheduled_mumimo;
	int num_ue_scheduled_mumimo;

	int * Schedule_map_write;
	vector <int> selected_ue;
	vector <int> scheduled_ue;

	MatrixXcd *W;

	void printCombination(VectorXd, VectorXd, double, int, int);
	void combinationUtil(VectorXd, VectorXd, VectorXd, double, int, int, int, int r);


	SCHEDULE_DECISION ** ppschedulewrite;

	void Read_Ch_Feedback(void);
	int  determine_MCS(double sinr_estimate);
	int determine_CQI(double sinr_estimate);
	void Initialize_schedule_map(void);
	void Set_AVR_Cqi(void);
	void Scheduling_RoundRobin(void);
	void Scheduling_Proportional_Fair_MU_MIMO(void); 


	void Scheduling(int);

	void Kill_Memory(void);

	double _N_pf;

	void Initial_Setting(int);
	void first_max_ue(int rb_idx);
	void SUS_procedure(int rb_idx);
	void Get_User_Set(int rb_idx);
	void Transmit_Precoding(int rb_idx);
	void Set_Min_Cqi(void);

	//complex <double> * W;


private:

	vector <int> user_set;

	double prev_max_sinr;
	double prev_sum_SINR;
	double sum_of_SINR;


};
