#include "sls_lls_mapping.h"


/*===================================================================
FUNCTION: eesm_methology( INPUT_TO_LLS_MAPPING  input , int _self_idx )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
LL_CURVE_LOOK eesm_methology(INPUT_TO_LLS_MAPPING  input, int _self_idx)
{
	setting_values(input, _self_idx);
	if (code_rate != 0)
	{
		Compute_beta();
		Compute_effective_sir();
		//print_eesm_rbir();

		/*
		int A = eesm_value_qpsk.size();
		int B = eesm_value_qam16.size();
		int C = eesm_value_qam64.size();

		if (A  < sample_size && mod_idx == 0) 
		{ 
			eesm_value_qpsk.push_back(input2table.snr); 
		}
		if (B < sample_size && mod_idx == 1) 
		{ 
			eesm_value_qam16.push_back(input2table.snr); 
		}
		if (C < sample_size && mod_idx == 2) 
		{ 
			eesm_value_qam64.push_back(input2table.snr); 
		}
		*/

	}
	else
	{
		input2table.snr = 0.0000000001;
	}
	return (input2table);

}
/*===================================================================
FUNCTION: rbir_methology( INPUT_TO_LLS_MAPPING input , int _self_idx  )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
LL_CURVE_LOOK rbir_methology(INPUT_TO_LLS_MAPPING input, int _self_idx)
{
	setting_values(input, _self_idx);
	if (code_rate != 0)
	{
		double si_sum = 0;

		int rbs_size = rbs_rx.size();

		for (int rbs_idx = 0; rbs_idx < rbs_size; rbs_idx++)
		{
			// double RBIR_SNR_MAPPING(int mod_order, double input, int mode)
			symbol_mutual_info[rbs_idx] = RBIR_SNR_MAPPING(mod_type, rbs_rx[rbs_idx], 0);
			si_sum += symbol_mutual_info[rbs_idx];
		}

		e_sir = RBIR_SNR_MAPPING(mod_type, si_sum / rbs_rx.size(), 1);

		input2table.snr = e_sir * snr_scale_factor;

		//cout << input2table.snr << endl;
		//getchar();

		//if( rbir_value_qpsk.size()  < sample_size && mod_idx == 0 ) { rbir_value_qpsk.push_back  ( input2table.snr ) ; }
		//if( rbir_value_qam16.size() < sample_size && mod_idx == 1 ) { rbir_value_qam16.push_back ( input2table.snr ) ; }
		//if( rbir_value_qam64.size() < sample_size && mod_idx == 2 ) { rbir_value_qam64.push_back ( input2table.snr ) ; }
	}
	else
	{
		input2table.snr = 0.0000000001;
	}

	return(input2table);

}// end of LL_CURVE_LOOK

/*===================================================================
FUNCTION: mib_methology( INPUT_TO_LLS_MAPPING input , int _self_idx  )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
LL_CURVE_LOOK mib_methology(INPUT_TO_LLS_MAPPING input, int _self_idx)
{
	return (input2table);
}

/*===================================================================
FUNCTION: setting_values( INPUT_TO_LLS_MAPPING  input , int _self_idx )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
void setting_values(INPUT_TO_LLS_MAPPING  input, int _self_idx)
{
	input2table.modulation_idx = input.mod_type;
	mod_type = input.mod_type;
	input2table.effective_code_rate = input.code_rate;
	code_rate = input.code_rate;
	snr_scale_factor = input.snr_scale_factor;

	rbs_rx.clear();
	symbol_mutual_info.clear();
	if (mod_type == QPSK)  
	{
		mod_idx = 0; 
	}
	else if (mod_type == QAM16)  
	{ 
		mod_idx = 1; 
	}
	else if (mod_type == QAM64)  
	{ 
		mod_idx = 2; 
	}
	else   {
		cout << "Something wrong with mod_type at rbir." << endl;
		cout << " mod_type = " << mod_type << endl;
		getchar();
	}

	ue_num = _self_idx;

	int ms_rbs_size = ms[_self_idx].rbs_rx.size();

	//cout << "ms_rbs_size = " << ms_rbs_size << endl;
	//getchar();


	for (int rbs_idx = 0; rbs_idx < ms_rbs_size; rbs_idx++)
	{
		rbs_rx.push_back(ms[_self_idx].rbs_rx[rbs_idx]);
		//cout << "ms[_self_idx].rbs_rx[rbs_idx] = " << ms[_self_idx].rbs_rx[rbs_idx] << endl;
		//getchar();
		symbol_mutual_info.push_back(0.);
	}
}

/*===================================================================
FUNCTION: Compute_beta( void

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
void Compute_beta(void)
{
	/*
	int target = 0;
	// cout << code_rate ; getchar();
	for (int i = 0; i < 4; i++)
	{
		if (code_rate >= CR_curves[i] && code_rate < CR_curves[i + 1])
		{
			target = i;
		}
	}
	if (code_rate == CR_curves[4]) 	{ target = 4; }
	//for check
	if (code_rate > CR_curves[4])
	{
		cout << " Warning!! Code rate is not acceptable. Code rate is " << code_rate << ". Check! " << endl; getchar();
	}
	if (target != 0 && target != 1 && target && target != 2 && target != 3 && target != 4)
	{
		cout << " Warning!! target at ue.cpp is not acceptable. target is " << target << "\t" << code_rate; getchar();
	}

	int index;
	if (mod_type == QPSK)   { index = 0; }
	else if (mod_type == QAM16)	  { index = 5; }
	else if (mod_type == QAM64)   { index = 10; }
	else                        { cerr << "Something Wrong" << endl; }

	if (target < 4)
	{
		e_beta = linear_cr(CR_curves[target], Beta[index + target],
			CR_curves[target + 1], Beta[index + target + 1], code_rate);
		e_beta = abs(e_beta); // have to check. decreased beta come out.
	}
	else if (target == 4)
	{
		e_beta = Beta[index + 4];
	}
	else
	{
		cout << "something wrong with e_beta(coderated beta) at ue.cpp "; getchar();
	}
	//for check
	if (e_beta < Beta[0] || e_beta > Beta[14])
	{
		cout << "sometheing wrong with e_beta at ue.cpp. e_beta is " << e_beta; getchar();
	}
	*/

	//cout << "ms[ue_num]._cqi_idx == " << ms[ue_num]._cqi_idx << endl;
	//getchar();

	if (ms[ue_num]._cqi_idx == 1)        { e_beta = 1.;   }
	else if (ms[ue_num]._cqi_idx == 2)   { e_beta = 1.4;  }
	else if (ms[ue_num]._cqi_idx == 3)   { e_beta = 1.4;  }
	else if (ms[ue_num]._cqi_idx == 4)   { e_beta = 1.48; }
	else if (ms[ue_num]._cqi_idx == 5)   { e_beta = 1.5;  }
	else if (ms[ue_num]._cqi_idx == 6)   { e_beta = 1.62; }
	else if (ms[ue_num]._cqi_idx == 7)   { e_beta = 3.1;  }
	else if (ms[ue_num]._cqi_idx == 8)   { e_beta = 4.32; }
	else if (ms[ue_num]._cqi_idx == 9)   { e_beta = 5.37; }
	else if (ms[ue_num]._cqi_idx == 10)  { e_beta = 7.71; }
	else if (ms[ue_num]._cqi_idx == 11)  { e_beta = 15.5; }
	else if (ms[ue_num]._cqi_idx == 12)  { e_beta = 19.6; }
	else if (ms[ue_num]._cqi_idx == 13)  { e_beta = 24.7; }
	else if (ms[ue_num]._cqi_idx == 14)  { e_beta = 27.6; }
	else if (ms[ue_num]._cqi_idx == 15)  { e_beta = 28.0; }
	else
	{
		cerr << "error e beta!" << endl;
		getchar();
	}

}

/*===================================================================
FUNCTION: Compute_effective_sir( void )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
void Compute_effective_sir(void)
{
	e_sir = 0;
	int rbs_size = rbs_rx.size();

	for (int i = 0; i < rbs_size; i++)
	{
		e_sir += exp(-rbs_rx[i] / e_beta);
	}

	e_sir = -e_beta * log(e_sir / (double)(rbs_rx.size()));
	input2table.snr = e_sir * snr_scale_factor;
	//input2table.snr = e_sir;
}


/*===================================================================
FUNCTION: si_computation( double sinr )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
double si_computation(double sinr)
{
	int table_idx = int(2 * sinr + 40);

	if (sinr < -20) { return (RBIR_value[mod_idx][0]); }
	else if (sinr > 27) { return (1); }
	else
	{
		return (linear_approx_f_c((double(table_idx) - 40.) / 2., RBIR_value[mod_idx][table_idx],
			(double(table_idx) + 1. - 40.) / 2., RBIR_value[mod_idx][table_idx + 1], sinr));
	}

}

/*===================================================================
FUNCTION: linear_approx_f_c( double a, double f_a , double b , double f_b , double c )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
double linear_approx_f_c(double a, double f_a, double b, double f_b, double c)
{
	return ((f_a*(b - c) + f_b*(c - a)) / (b - a));
}
double linear_approx_c(double a, double f_a, double b, double f_b, double f_c)
{
	return ((b*(f_c - f_a) + a*(f_b - f_c)) / (f_b - f_a));
}


/*===================================================================
FUNCTION: back_lookup_talbe( double si_final )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
double back_lookup_talbe(double si_final)
{
	int table_idx;

	if (si_final <  RBIR_value[mod_idx][0]) { table_idx = -100; }
	else if (si_final == 1) { table_idx = 94; }
	else
	{
		for (int idx = 0; idx < 93; idx++)
		{
			if (si_final >= RBIR_value[mod_idx][idx] && si_final < RBIR_value[mod_idx][idx + 1])
			{
				table_idx = idx;
			}
		}
	}
	if (si_final <  RBIR_value[mod_idx][0]) { return (-20.); }
	else if (si_final >= RBIR_value[mod_idx][94]) { return (27.); }
	else
	{
		return (linear_approx_c((double(table_idx) - 40.) / 2., RBIR_value[mod_idx][table_idx],
			(double(table_idx) + 1. - 40.) / 2., RBIR_value[mod_idx][table_idx + 1], si_final));
	}
}

/*===================================================================
FUNCTION: print_eesm_rbir( double si_final )

AUTHOR: KR

DESCRIPTION:

NOTES:

===================================================================*/
void print_eesm_rbir(void)
{
	ofstream  OutputFile;

	if (eesm_value_qpsk.size() == sample_size &&  drop_idx == 0)
	{
		OutputFile.open("./Logging_point/EESM_RESULT/qpsk_eesm.dat");

		int qpsk_size = eesm_value_qpsk.size();

		for (int i = 0; i < qpsk_size; i++)
		{
			OutputFile << linear2dB(eesm_value_qpsk[i]) << endl;
		}
		OutputFile.close();

		OutputFile.open("./Logging_point/EESM_RESULT/qam16_eesm.dat");

		int qam_16_size = eesm_value_qam16.size();

		for (int i = 0; i < qam_16_size; i++)
		{
			OutputFile << linear2dB(eesm_value_qam16[i]) << endl;
		}
		OutputFile.close();

		OutputFile.open("./Logging_point/EESM_RESULT/qam64_eesm.dat");

		int qam_64_size = eesm_value_qam64.size();

		for (int i = 0; i < qam_64_size; i++)
		{
			OutputFile << linear2dB(eesm_value_qam64[i]) << endl;
		}
		OutputFile.close();

		OutputFile.open("./Logging_point/EESM_RESULT/qpsk_rbir.dat");

		int rbir_qpsk_size = rbir_value_qpsk.size();

		for (int i = 0; i < rbir_qpsk_size; i++)
		{
			OutputFile << linear2dB(rbir_value_qpsk[i]) << endl;
		}
		OutputFile.close();

		OutputFile.open("./Logging_point/EESM_RESULT/qam16_rbir.dat");

		int rbir_qam16_size = rbir_value_qam16.size();

		for (int i = 0; i < rbir_qam16_size; i++)
		{
			OutputFile << linear2dB(rbir_value_qam16[i]) << endl;
		}
		OutputFile.close();

		OutputFile.open("./Logging_point/EESM_RESULT/qam64_rbir.dat");

		int eesm_qam_64_size = eesm_value_qam64.size();

		for (int i = 0; i < eesm_qam_64_size; i++)
		{
			OutputFile << linear2dB(rbir_value_qam64[i]) << endl;
		}
		OutputFile.close();

		eesm_value_qpsk.push_back(0);
		rbir_value_qpsk.push_back(0);

	}
}



double RBIR_SNR_MAPPING(int mod_order, double input, int mode) // mode 0: SNR -> RBIR, mode 1: RBIR -> SNR
{
	int i = 0;
	int data_range = 0;
	int mod_idx = 0;
	double in_SNR = 0.;
	double out_SNR = 0.;
	double in_RBIR = 0.;
	double out_RBIR = 0.;

	data_range = 95;
	mod_idx = int(double(mod_order) / 2) - 1;

	if (mode == 0){///// SNR -> RBIR
		if (input == 0)	in_SNR = -100;
		else			in_SNR = 10 * log10(input);

		if (in_SNR<SNR[0]) // outerpolation
		{
			out_RBIR = ((SNR[1] - in_SNR)*RBIR[mod_idx][0] - (SNR[0] - in_SNR)*RBIR[mod_idx][1]) / (SNR[1] - SNR[0]);
			if (out_RBIR < 0) out_RBIR = 0;
		}

		else if (in_SNR >= SNR[data_range - 1])
			out_RBIR = 1.;

		else{ // interpolation
			for (i = 0; i<data_range - 1; i++){
				if (SNR[i] <= in_SNR && SNR[i + 1]>in_SNR){
					out_RBIR = ((RBIR[mod_idx][i] - RBIR[mod_idx][i + 1])*in_SNR + SNR[i] * RBIR[mod_idx][i + 1] - SNR[i + 1] * RBIR[mod_idx][i]) / (SNR[i] - SNR[i + 1]);
				}
			}
		}
		return out_RBIR;
	}
	else{///// RBIR -> SNR
		in_RBIR = input;

		if (in_RBIR<RBIR[mod_idx][0]) // outerpolation
			out_SNR = ((RBIR[mod_idx][1] - in_RBIR)*SNR[0] - (RBIR[mod_idx][0] - in_RBIR)*SNR[1]) / (RBIR[mod_idx][1] - RBIR[mod_idx][0]);

		else if (in_RBIR >= RBIR[mod_idx][data_range - 1]){ // the smallest SNR whose RBIR value is one (specific value according to RBIR-SNR mapping table)
			if (mod_idx == 0) out_SNR = SNR[65];
			else if (mod_idx == 1) out_SNR = SNR[79];
			else if (mod_idx == 2) out_SNR = SNR[91];
		}

		else{ // interpolation
			for (i = 0; i<data_range - 1; i++){
				if (RBIR[mod_idx][i] <= in_RBIR && RBIR[mod_idx][i + 1]>in_RBIR){
					out_SNR = ((SNR[i] - SNR[i + 1])*in_RBIR + RBIR[mod_idx][i] * SNR[i + 1] - RBIR[mod_idx][i + 1] * SNR[i]) / (RBIR[mod_idx][i] - RBIR[mod_idx][i + 1]);
				}
			}
		}
		return pow(10., out_SNR / 10.);
	}
}

